#!/usr/bin/perl -w 
#You must have the comment above for Active Perl to work!

#Programmer....: Michael Thomas  michael@michael-thomas.com
#Source Code...: Feel free to modify the code and call it yours!
#                Enjoy Success!
#Description...: Email's a Form using SMTP
#Orig Date.....: 02/17/00
#
#Note..........: To make this Perl script work, you need to enter a valid SMTP mail server
#                in the statement(Net::SMTP->new('<your SMTP Server Name>');
#                SMTP mail server - same as you OUTGOING mail server.

#************************************************************************************
# Start:  Must customize this code.  Enter your SMTP mail server name (Outgoing Mail)
#************************************************************************************
#Next, open connection to SMTP mail server

  $strSMTPMailServer = '<enter your SMTP Mail server name here> ex: mail.abccompany.com';
  
  use Net::SMTP;
  $smtp = Net::SMTP->new($strSMTPMailServer); 
  
#************************************************************************************

  #Email variables.
  $fullname = "";   #valued with Form's field:  mail_fullname
  $from     = "";   #valued with     "          mail_from
  $to       = "";   #valued with     "          mail_to
  $cc       = "";   #valued with     "          mail_cc
  $bc       = "";   #valued with     "          mail_bc
  $subject  = "";   #valued with     "          mail_subject
  $body     = "";   #valued with     "          mail_body
  $thanks   = "";   #valued with     "          mail_thanks

  #Other variables ( 0=false, 1=true)
  $blnTechInfo      = 0;  #Adds technical information to screen.
  $blnThanksIsALink = 0;  #Is the value in $thanks a link or HTML.
  $blnContinue      = 0;  #If passes validation, then 1.
  $strDebugMsg      = ""; #Used to pass debug info arround.  $blnTechInfo also.

  use CGI;
  $cgi = CGI::new();

  subLoadEmailVars();                       #load vars from Email form.
  $blnContinue = subEmailVarsValidate();     #validate the Email forms values.

  if ( $blnContinue ) {

    $blnThanksIsALink = subThanksIsALink();   #determine if $thanks is a link or html

    subEmailSmtp();                           #Email data using SMTP. 

    if ( $blnThanksIsALink ) {
      print "Location: $thanks\n\n";          #Go to a URL link.
    } else {
      subPrintThanksHtml();                   #Return HTML to browser.
    }

  }#if blnContinue

  $smtp->quit;  
  
#------------------------------------------------------------------------------
sub subThanksIsALink {
#------------------------------------------------------------------------------
#Find out if mail_thanks is a link or html.

  local $strLcThanks = "";
  local $blnThanksIsALink = 0;

  $strLcThanks = lc $thanks;
  if ( index( $strLcThanks, 'http://' ) == 0 ||
       index( $strLcThanks,  './'     ) == 0 ||
       index( $strLcThanks,  '../'    ) == 0    ) {
    $blnThanksIsALink = 1;
  } else {
    $blnThanksIsALink = 0;
  }

  return $blnThanksIsALink;
}

#------------------------------------------------------------------------------
sub subLoadEmailVars {
#------------------------------------------------------------------------------
# Load variables from the FORM's values

  if ($cgi->param()) {
  
      $fullname = $cgi->param('mail_fullname');
      
      $from     = $cgi->param('mail_from');
      $from     = subEmailFormat($from);
 
      $to       = $cgi->param('mail_to');
      $to       = subEmailFormat($to);
  
      $cc       = $cgi->param('mail_cc');
      $cc       = subEmailFormat($cc);
  
      $bc       = $cgi->param('mail_bc');
      $bc       = subEmailFormat($bc);
  
      $subject  = $cgi->param('mail_subject');
  
      $body     = $cgi->param('mail_body');
      $body     =~ s/</&lt;/g;  
      # Searchfor '<' and replace with '&lt;' globally ('g').
      # Replace '<' with '&lt;' for security reasons - redirecting from system.
  
      $thanks   = $cgi->param('mail_thanks');
  }

}

#------------------------------------------------------------------------------
sub subEmailFormat {
#------------------------------------------------------------------------------

  local $strEmail = shift(@_);  

  $strEmail =~ s/@/\@/g;    #Searchfor '@' and replace with '\@' globally ('g')

  return $strEmail; 
}
#------------------------------------------------------------------------------
sub subEmailVarsValidate {
#------------------------------------------------------------------------------
#
  local $blnOK = 1;
  local $strErrorMsg = "";

  $blnOK = 1;  #Everything is OK, unless error found below.

  $strErrAdd = subValidAddress( $to, "TO" );

  if ( $strErrAdd ) {
    $strErrorMsg = $strErrorMsg . $strErrAdd;
    $blnOK = 0;
  }

  if ( $blnOK == 0 ) {

    #Error Message

    print $cgi->header();
  
    print "<html><head>\n";
    print "<title>Error Message</title>\n";
    print "</head>\n";
    print "<body>\n";
    print "<h1>Error Message</h1>\n";

    print $cgi->p( $strErrorMsg , "\n");
                                        
    print $cgi->p( "<center><a href='javascript: window.history.back()'>Click here to correct errors.</a></center>" , "\n");

    print "</body>\n";
    print "</html>\n";
  
  }

  return $blnOK;

}
#------------------------------------------------------------------------------
sub subValidAddress {
#------------------------------------------------------------------------------
# Validate the email address.  Remember you can have multiple address on 
#   one line.
#
  local $strSendTo      = shift(@_);  #load parameters.
  local $strSendToField = shift(@_);

  local $strErrorMsg    = "";

  local @aSendTo = subEmailMakeArray( $strSendTo );

  #Check for something in the Field.
  if ( $#aSendTo == -1 ) {
      $strErrorMsg = $strErrorMsg . "Err#0, Invalid Email Field:  " . 
                     $strSendToField .
                     " - is empty " .
                     "<br>\n";
  }

  for (local $i=0; $i <= $#aSendTo; $i++ ) {
    #Multiple line checks.

    if ( $aSendTo[$i] eq "" ) {
      $strErrorMsg = $strErrorMsg . "Err#1, Invalid Email Field:  " . 
                     $strSendToField .
                     ", email #" . $i .
                     " - is empty " .
                     "<br>\n";
    }

    if ( $aSendTo[$i] ne "" && index($aSendTo[$i],"@") <= 0 ) {
      $strErrorMsg = $strErrorMsg . "Err#2, Invalid Email Field:  " . 
                     $strSendToField .
                     ", email #" . $i .
                     " - missing or invalid placement of \@ sign: " . $aSendTo[$i] .
                     "<br>\n";
    }

  } #for

  return $strErrorMsg;

}

#------------------------------------------------------------------------------
sub subEmailSmtp {
#------------------------------------------------------------------------------
# Write EMail to SMTP server.

  $smtp->mail($from);

  subEmailParseAddress( $to );
  subEmailParseAddress( $cc );
  subEmailParseAddress( $bc );

  $smtp->data(); 
  $smtp->datasend("From: ", $fullname, "<", $from , ">", "\n"); 
  $smtp->datasend("To: ", $to, "\n"); 
  $smtp->datasend("Cc: ", $cc, "\n"); 
  $smtp->datasend("Subject: ", $subject, "\n"); 
  $smtp->datasend("\n"); 
  $smtp->datasend($body); 
  $smtp->dataend(); 
}
#------------------------------------------------------------------------------
sub subEmailParseAddress {
#------------------------------------------------------------------------------

  local $strSendTo     = shift(@_);
  local $blnDebugLocal = 1;

  if ( $strSendTo ) {

    @aSendTo = subEmailMakeArray( $strSendTo );

    for (local $i=0; $i <= $#aSendTo; $i++ ) {
  
      if ( $blnDebugLocal ) { $strDebugMsg = $strDebugMsg . $aSendTo[$i] . ", "; }
  
      #Send email to the array of addresses.
      $smtp->to( $aSendTo[$i] );  #smtp's to() function - send to.
  
    }
  
    if ( $blnDebugLocal ) { $strDebugMsg = $strDebugMsg . "<br>\n<br>\n"; }

  } 
}
#------------------------------------------------------------------------------
sub subEmailMakeArray {
#------------------------------------------------------------------------------

  local $strSendTo = shift(@_);

  local @aSendTo = split(",", $strSendTo);  #Creates an array using space as delimiter.
  
  return @aSendTo;

}
#------------------------------------------------------------------------------
sub subPrintThanksHtml {
#------------------------------------------------------------------------------
#Print HTML message to Browser

  print $cgi->header();

  print "<html><head>\n";
  print "<title>Thank You</title>\n";
  print "</head>\n";
  print "<body>\n";

  print $cgi->p($thanks , "\n");

  if ( $blnTechInfo ) {
  
    print $cgi->hr();
    print $cgi->h1("Technical Information" , "\n"); 
    print $cgi->hr();
    print $cgi->p( "domain = ", $smtp->domain(), "\n"); 
    print $cgi->p( "SMTP hostname = ", $strSMTPMailServer, "\n"); 
    
    print $cgi->p("Sending an email. <br>\n<br>\n",
                   "user from ENV = ", $ENV{USER} ,"<br>\n",
                   "full name = "    , $fullname  ,"<br>\n",
                   "from = "         , $from      ,"<br>\n",
                   "to = "           , $to        ,"<br>\n",
                   "cc = "           , $cc        ,"<br>\n",
                   "bc = "           , $bc        ,"<br>\n",
                   "subject = "      , $subject   ,"<br>\n",
                   "body = "         , $body      ,"<br>\n",);

    print $cgi->hr(); 

    print $cgi->p("Debugging Info (if any)<br>\n<br>\n",
                  $strDebugMsg );

    print $cgi->hr(); 

  }
  
  print "</body>\n";
  print "</html>\n";

}